/*
 * n01_stats
 *
 * option.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>

#include "General.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern OPTION op;

/* Local Function Prototypes */
static BOOL CALLBACK option_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * option_proc - EBhEvV[W
 */
static BOOL CALLBACK option_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, IDC_CHECK_DATA_TO_CSV, BM_SETCHECK, op.csv_update, 0);
		SendDlgItemMessage(hDlg, IDC_CHECK_SPLIT_DATA, BM_SETCHECK, op.auto_split, 0);
		SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_SETTEXT, 0, (LPARAM)op.auto_split_sep);
		SendDlgItemMessage(hDlg, IDC_CHECK_DELETE, BM_SETCHECK, op.auto_split_delete, 0);

		SendMessage(hDlg, WM_COMMAND, (WPARAM)IDC_CHECK_SPLIT_DATA, 0);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_CHECK_SPLIT_DATA:
			EnableWindow(GetDlgItem(hDlg, IDC_EDIT_SEP), SendDlgItemMessage(hDlg, IDC_CHECK_SPLIT_DATA, BM_GETCHECK, 0, 0));
			EnableWindow(GetDlgItem(hDlg, IDC_CHECK_DELETE), SendDlgItemMessage(hDlg, IDC_CHECK_SPLIT_DATA, BM_GETCHECK, 0, 0));
			break;

		case IDOK:
			if (SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_GETTEXTLENGTH, 0, 0) <= 0) {
				break;
			}
			op.csv_update = SendDlgItemMessage(hDlg, IDC_CHECK_DATA_TO_CSV, BM_GETCHECK, 0, 0);
			op.auto_split = SendDlgItemMessage(hDlg, IDC_CHECK_SPLIT_DATA, BM_GETCHECK, 0, 0);
			SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)op.auto_split_sep);
			op.auto_split_delete = SendDlgItemMessage(hDlg, IDC_CHECK_DELETE, BM_GETCHECK, 0, 0);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_option - IvVʕ\
 */
BOOL show_option(const HINSTANCE hInst, const HWND hWnd)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OPTION), hWnd, option_proc, 0);
}
/* End of source */
