/*
 * n01_stats
 *
 * player.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>
#include <stdio.h>
#include <commctrl.h>

#include "General.h"
#include "string.h"
#include "Memory.h"
#include "Message.h"
#include "listview.h"
#include "file.h"
#include "csv.h"
#include "data.h"
#include "index.h"
#include "player.h"
#include "score_list.h"

#include "resource.h"

/* Define */
#ifndef LVM_SETSELECTEDCOLUMN
#define LVM_SETSELECTEDCOLUMN	(LVM_FIRST + 140)
#endif
#ifndef ListView_SetSelectedColumn
#define ListView_SetSelectedColumn(hwnd, iCol) \
			SNDMSG((hwnd), LVM_SETSELECTEDCOLUMN, (WPARAM)iCol, 0)
#endif

/* Global Variables */
static CSV_SCORE csvs;
static SCORE_INFO si;

extern HWND g_main_wnd;
extern OPTION op;
extern TCHAR index_file[];
extern TCHAR csv_path[];

extern DATA_INFO *g_di;
extern int g_di_count;
extern DATA_INFO *g_show_di;
extern int g_show_di_count;

/* Local Function Prototypes */
static BOOL CALLBACK player_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * set_listview_stats - ACe̒ǉ
 */
static int set_listview_stats(const HWND hListView, TCHAR *title, TCHAR *value1, TCHAR *value2)
{
	LV_ITEM lvi;
	int i;

	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	lvi.iItem = ListView_GetItemCount(hListView);
	lvi.iSubItem = 0;
	lvi.pszText = title;
	lvi.cchTextMax = BUF_SIZE - 1;
	lvi.iImage = 0;
	lvi.lParam = 0;
	i = ListView_InsertItem(hListView, &lvi);
	ListView_SetItemText(hListView, i, 1, value1);
	ListView_SetItemText(hListView, i, 2, value2);
	return i;
}

/*
 * show_listview_stats - v̕\
 */
static void show_listview_stats(const HWND hListView, const int di_index)
{
	LV_COLUMN lvc;
	DATA_INFO *di1, *di2;
	TCHAR buf1[BUF_SIZE];
	TCHAR buf2[BUF_SIZE];

	di1 = &g_di[di_index];
	di2 = &g_di[g_di[di_index].vs_index];

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 150;
	lvc.pszText = message_get_res(IDS_STRING_VIEW_CONTENT);
	lvc.iSubItem = 0;
	ListView_InsertColumn(hListView, lvc.iSubItem, &lvc);

	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 120;
	lvc.pszText = di1->name;
	lvc.iSubItem = 1;
	ListView_InsertColumn(hListView, lvc.iSubItem, &lvc);

	lvc.fmt = LVCFMT_LEFT;
	lvc.cx = 120;
	lvc.pszText = di2->name;
	lvc.iSubItem = 2;
	ListView_InsertColumn(hListView, lvc.iSubItem, &lvc);

	SendMessage(hListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_INFOTIP | LVS_EX_FULLROWSELECT);

	set_listview_stats(hListView,
		data_get_title(HDTP_START_SCORE), data_to_value(HDTP_START_SCORE, di1, buf1), data_to_value(HDTP_START_SCORE, di2, buf2));

	set_listview_stats(hListView,
		data_get_title(HDTP_SETS_PLAYED), data_to_value(HDTP_SETS_PLAYED, di1, buf1), data_to_value(HDTP_SETS_PLAYED, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_SETS_WON), data_to_value(HDTP_SETS_WON, di1, buf1), data_to_value(HDTP_SETS_WON, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_LEGS_PLAYED), data_to_value(HDTP_LEGS_PLAYED, di1, buf1), data_to_value(HDTP_LEGS_PLAYED, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_LEGS_WON), data_to_value(HDTP_LEGS_WON, di1, buf1), data_to_value(HDTP_LEGS_WON, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_TON), data_to_value(HDTP_TON, di1, buf1), data_to_value(HDTP_TON, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_TON00), data_to_value(HDTP_TON00, di1, buf1), data_to_value(HDTP_TON00, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_TON40), data_to_value(HDTP_TON40, di1, buf1), data_to_value(HDTP_TON40, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_TON80), data_to_value(HDTP_TON80, di1, buf1), data_to_value(HDTP_TON80, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_HIGH_OFF), data_to_value(HDTP_HIGH_OFF, di1, buf1), data_to_value(HDTP_HIGH_OFF, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_SHORT_GAME), data_to_value(HDTP_SHORT_GAME, di1, buf1), data_to_value(HDTP_SHORT_GAME, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_LONG_GAME), data_to_value(HDTP_LONG_GAME, di1, buf1), data_to_value(HDTP_LONG_GAME, di2, buf2));

	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_SET), data_to_value(HDTP_AVG_SET, di1, buf1), data_to_value(HDTP_AVG_SET, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_LEG), data_to_value(HDTP_AVG_LEG, di1, buf1), data_to_value(HDTP_AVG_LEG, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_DARTS), data_to_value(HDTP_AVG_DARTS, di1, buf1), data_to_value(HDTP_AVG_DARTS, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_SCORE), data_to_value(HDTP_AVG_SCORE, di1, buf1), data_to_value(HDTP_AVG_SCORE, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_FIRST9), data_to_value(HDTP_AVG_FIRST9, di1, buf1), data_to_value(HDTP_AVG_FIRST9, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_CHECK_OUT_VIEW), data_to_value(HDTP_AVG_CHECK_OUT_VIEW, di1, buf1), data_to_value(HDTP_AVG_CHECK_OUT_VIEW, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_KEEP_LEGS_VIEW), data_to_value(HDTP_AVG_KEEP_LEGS_VIEW, di1, buf1), data_to_value(HDTP_AVG_KEEP_LEGS_VIEW, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_AVG_BREAK_LEGS_VIEW), data_to_value(HDTP_AVG_BREAK_LEGS_VIEW, di1, buf1), data_to_value(HDTP_AVG_BREAK_LEGS_VIEW, di2, buf2));

	set_listview_stats(hListView,
		data_get_title(HDTP_SUCCESS_2_80), data_to_value(HDTP_SUCCESS_2_80, di1, buf1), data_to_value(HDTP_SUCCESS_2_80, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_FAILURE_2_80), data_to_value(HDTP_FAILURE_2_80, di1, buf1), data_to_value(HDTP_FAILURE_2_80, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_SUCCESS_81_130), data_to_value(HDTP_SUCCESS_81_130, di1, buf1), data_to_value(HDTP_SUCCESS_81_130, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_FAILURE_81_130), data_to_value(HDTP_FAILURE_81_130, di1, buf1), data_to_value(HDTP_FAILURE_81_130, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_SUCCESS_131), data_to_value(HDTP_SUCCESS_131, di1, buf1), data_to_value(HDTP_SUCCESS_131, di2, buf2));
	set_listview_stats(hListView,
		data_get_title(HDTP_FAILURE_131), data_to_value(HDTP_FAILURE_131, di1, buf1), data_to_value(HDTP_FAILURE_131, di2, buf2));
}

/*
 * show_score_list - XRAꗗ̕\
 */
static void show_score_list(const HWND hDlg, const int index)
{
	static LEG_INFO leg;
	TCHAR buf[BUF_SIZE];

	si.player[0].start_score = csvs.csvsi[index].start_score;
	si.player[1].start_score = csvs.csvsi[index + 1].start_score;
	si.leg = &leg;
	si.leg->first = csvs.csvsi[index].first;
	si.leg->max_round = csvs.csvsi[index].round + 1;
	si.leg->current_round = csvs.csvsi[index].round;
	si.leg->current_player = csvs.csvsi[index].player;
	si.leg->score[0] = csvs.csvsi[index].score;
	si.leg->score[1] = csvs.csvsi[index + 1].score;
	SendDlgItemMessage(hDlg, IDC_VIEW_SCORE, WM_SCORE_SET_INFO, 0, (LPARAM)&si);
	SendDlgItemMessage(hDlg, IDC_VIEW_SCORE, WM_SCORE_SHOW_LEG, 0, 0);

	if (csvs.csvsi[index].darts > 0) {
		wsprintf(buf, message_get_res(IDS_STRING_OP_LIST_DARTS), csvs.csvsi[index].darts);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_P1), buf);
		ShowWindow(GetDlgItem(hDlg, IDC_STATIC_P1), SW_SHOW);
	}
	if (csvs.csvsi[index + 1].darts > 0) {
		wsprintf(buf, message_get_res(IDS_STRING_OP_LIST_DARTS), csvs.csvsi[index + 1].darts);
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_P2), buf);
		ShowWindow(GetDlgItem(hDlg, IDC_STATIC_P2), SW_SHOW);
	}
}

/*
 * get_control_pos_right - Rg[̃NCAgW擾
 */
static void get_control_pos_right(const HWND hDlg, RECT *c_rect)
{
	RECT rect;
	POINT pt;

	GetClientRect(hDlg, &rect);

	c_rect->right = c_rect->right - c_rect->left;
	c_rect->bottom = c_rect->bottom - c_rect->top;
	pt.x = c_rect->left;
	pt.y = c_rect->top;
	ScreenToClient(hDlg, &pt);
	c_rect->left = rect.right - pt.x;
	c_rect->top = rect.bottom - pt.y;
}

/*
 * player_proc - EBhEvV[W
 */
static BOOL CALLBACK player_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	DATA_INFO *di;
	DATA_INFO *di1;
	RECT rect;
	POINT pt;
	SYSTEMTIME dt, tim;
	TCHAR err_str[BUF_SIZE];
	TCHAR path[MAX_PATH];
	TCHAR buf1[BUF_SIZE];
	int di_index;
	int i;
	static RECT score_rect, p1_rect, p2_rect, out_rect, ok_rect, cancel_rect;

	switch (msg) {
	case WM_INITDIALOG:
		if (g_di[lParam].index >= 0) {
			i = g_di[lParam].index;
		} else {
			i = lParam;
		}
		if (i < g_di[i].vs_index) {
			di_index = i;
		} else {
			di_index = g_di[i].vs_index;
		}
		SetWindowLong(hDlg, GWL_USERDATA, di_index);
		di = &g_di[di_index];

		// Rg[̏W擾
		GetClientRect(hDlg, &rect);
		GetWindowRect(GetDlgItem(hDlg, IDC_LIST_STATS), &score_rect);
		pt.x = 0;
		pt.y = score_rect.top;
		ScreenToClient(hDlg, &pt);
		score_rect.top = pt.y;
		pt.x = 0;
		pt.y = score_rect.bottom;
		ScreenToClient(hDlg, &pt);
		score_rect.bottom = rect.bottom - pt.y + score_rect.top;

		GetWindowRect(GetDlgItem(hDlg, IDC_STATIC_P1), &p1_rect);
		get_control_pos_right(hDlg, &p1_rect);
		GetWindowRect(GetDlgItem(hDlg, IDC_STATIC_P2), &p2_rect);
		get_control_pos_right(hDlg, &p2_rect);

		GetWindowRect(GetDlgItem(hDlg, IDC_BUTTON_DATA_OUT), &out_rect);
		get_control_pos_right(hDlg, &out_rect);
		GetWindowRect(GetDlgItem(hDlg, IDOK), &ok_rect);
		get_control_pos_right(hDlg, &ok_rect);
		GetWindowRect(GetDlgItem(hDlg, IDCANCEL), &cancel_rect);
		get_control_pos_right(hDlg, &cancel_rect);

		// EBhËʒuATCYݒ
		if (op.score_list_rect.right > 0 && op.score_list_rect.bottom > 0) {
			SetWindowPos(hDlg, 0,
				op.score_list_rect.left, op.score_list_rect.top,
				op.score_list_rect.right, op.score_list_rect.bottom, SWP_NOZORDER);
		}
		SendMessage(hDlg, WM_SIZE, 0, 0);

		SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_SETTEXT, 0, (LPARAM)di->name);
		SendDlgItemMessage(hDlg, IDC_EDIT_NAME, EM_SETMODIFY, FALSE, 0);
		SendDlgItemMessage(hDlg, IDC_EDIT_VS_NAME, WM_SETTEXT, 0, (LPARAM)g_di[di->vs_index].name);
		SendDlgItemMessage(hDlg, IDC_EDIT_VS_NAME, EM_SETMODIFY, FALSE, 0);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_DATE, DTM_SETSYSTEMTIME, 0, (LPARAM)&di->start_time);
		SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_TIME, DTM_SETSYSTEMTIME, 0, (LPARAM)&di->start_time);
		*path = TEXT('\0');
		if (file_find(csv_path, di->file_name, path) == FALSE) {
			SendDlgItemMessage(hDlg, IDC_EDIT_FILE_NAME, WM_SETTEXT, 0, (LPARAM)di->file_name);
		} else {
			SendDlgItemMessage(hDlg, IDC_EDIT_FILE_NAME, WM_SETTEXT, 0, (LPARAM)path);
		}

		SendDlgItemMessage(hDlg, IDC_COMBO_LEG, CB_ADDSTRING, 0, (LPARAM)message_get_res(IDS_STRING_VIEW_STATS));
		for (i = 0; i < csvs.csvsi_count; i += 2) {
			wsprintf(buf1, message_get_res(IDS_STRING_OP_LIST_LEG), (i / 2) + 1);
			SendDlgItemMessage(hDlg, IDC_COMBO_LEG, CB_ADDSTRING, 0, (LPARAM)buf1);
		}
		SendDlgItemMessage(hDlg, IDC_COMBO_LEG, CB_SETCURSEL, 0, 0);
		ShowWindow(GetDlgItem(hDlg, IDC_VIEW_SCORE), SW_HIDE);
		show_listview_stats(GetDlgItem(hDlg, IDC_LIST_STATS), di_index);
		ListView_SetItemState(GetDlgItem(hDlg, IDC_LIST_STATS), 0, LVIS_FOCUSED, LVIS_FOCUSED);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_SIZE:
		GetClientRect(hDlg, &rect);

		MoveWindow(GetDlgItem(hDlg, IDC_LIST_STATS), 0, score_rect.top, rect.right, rect.bottom - score_rect.bottom, TRUE);
		MoveWindow(GetDlgItem(hDlg, IDC_VIEW_SCORE), 0, score_rect.top, rect.right, rect.bottom - score_rect.bottom - p1_rect.bottom, TRUE);
		MoveWindow(GetDlgItem(hDlg, IDC_STATIC_P1), 0, rect.bottom - p1_rect.top, p1_rect.right, p1_rect.bottom, TRUE);
		MoveWindow(GetDlgItem(hDlg, IDC_STATIC_P2), rect.right - p2_rect.left, rect.bottom - p2_rect.top, p2_rect.right, p2_rect.bottom, TRUE);

		MoveWindow(GetDlgItem(hDlg, IDC_BUTTON_DATA_OUT), 10, rect.bottom - out_rect.top, out_rect.right, out_rect.bottom, TRUE);
		MoveWindow(GetDlgItem(hDlg, IDOK), rect.right - ok_rect.left, rect.bottom - ok_rect.top, ok_rect.right, ok_rect.bottom, TRUE);
		MoveWindow(GetDlgItem(hDlg, IDCANCEL), rect.right - cancel_rect.left, rect.bottom - cancel_rect.top, cancel_rect.right, cancel_rect.bottom, TRUE);

		InvalidateRect(GetDlgItem(hDlg, IDOK), NULL, FALSE);
		UpdateWindow(GetDlgItem(hDlg, IDOK));
		InvalidateRect(GetDlgItem(hDlg, IDCANCEL), NULL, FALSE);
		UpdateWindow(GetDlgItem(hDlg, IDCANCEL));
		break;

	case WM_EXITSIZEMOVE:
		// TCYύX
		if (IsWindowVisible(hDlg) != 0 && IsIconic(hDlg) == 0 && IsZoomed(hDlg) == 0) {
			GetWindowRect(hDlg, (LPRECT)&op.score_list_rect);
			op.score_list_rect.right -= op.score_list_rect.left;
			op.score_list_rect.bottom -= op.score_list_rect.top;
		}
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_COMBO_LEG:
			if (HIWORD(wParam) == CBN_SELENDOK) {
				i = SendDlgItemMessage(hDlg, IDC_COMBO_LEG, CB_GETCURSEL, 0, 0);
				if (i < 0) {
					break;
				}
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC_P1), SW_HIDE);
				ShowWindow(GetDlgItem(hDlg, IDC_STATIC_P2), SW_HIDE);
				if (i == 0) {
					ShowWindow(GetDlgItem(hDlg, IDC_LIST_STATS), SW_SHOW);
					ShowWindow(GetDlgItem(hDlg, IDC_VIEW_SCORE), SW_HIDE);
				} else {
					show_score_list(hDlg, (i - 1) * 2);
					ShowWindow(GetDlgItem(hDlg, IDC_LIST_STATS), SW_HIDE);
					ShowWindow(GetDlgItem(hDlg, IDC_VIEW_SCORE), SW_SHOW);
				}
			}
			break;

		case IDC_BUTTON_DATA_OUT:
			// f[^o
			data_show_data(hDlg, &g_di[GetWindowLong(hDlg, GWL_USERDATA)]);
			break;

		case IDOK:
			// f[^XV
			di_index = GetWindowLong(hDlg, GWL_USERDATA);
			di = &g_di[di_index];

			ZeroMemory(&dt, sizeof(SYSTEMTIME));
			SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_DATE, DTM_GETSYSTEMTIME, 0, (LPARAM)&dt);
			SendDlgItemMessage(hDlg, IDC_DATETIMEPICKER_TIME, DTM_GETSYSTEMTIME, 0, (LPARAM)&tim);
			dt.wHour = tim.wHour;
			dt.wMinute = tim.wMinute;
			dt.wSecond = tim.wSecond;

			if (SendDlgItemMessage(hDlg, IDC_EDIT_NAME, EM_GETMODIFY, 0, 0) == FALSE &&
				SendDlgItemMessage(hDlg, IDC_EDIT_VS_NAME, EM_GETMODIFY, 0, 0) == FALSE &&
				dt.wYear == di->start_time.wYear && dt.wMonth == di->start_time.wMonth && dt.wDay == di->start_time.wDay &&
				dt.wHour == di->start_time.wHour && dt.wMinute == di->start_time.wMinute && dt.wSecond == di->start_time.wSecond) {
				// XV
				EndDialog(hDlg, TRUE);
				break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_GETTEXT, NAME_SIZE - 1, (LPARAM)di->name);
			di->name_hash = str2hash(di->name);
			SendDlgItemMessage(hDlg, IDC_EDIT_VS_NAME, WM_GETTEXT, NAME_SIZE - 1, (LPARAM)g_di[di->vs_index].name);
			g_di[di->vs_index].name_hash = str2hash(g_di[di->vs_index].name);
			g_di[di->vs_index].start_time = di->start_time = dt;

			// \f[^XV
			for (i = 0; i < g_show_di_count; i++) {
				di1 = NULL;
				if (g_show_di[i].index == di_index) {
					di1 = di;
				} else if (g_show_di[i].index == di->vs_index) {
					di1 = &g_di[di->vs_index];
				}
				if (di1 != NULL) {
					lstrcpy(g_show_di[i].name, di1->name);
					g_show_di[i].name_hash = di1->name_hash;
					g_show_di[i].start_time = di1->start_time;
				}
			}
			index_save(index_file, g_di, di_index, di_index + 1);
			index_save(index_file, g_di, di->vs_index, di->vs_index + 1);
			SendMessage(g_main_wnd, WM_MAIN_REFRESH, 0, 0);
			if (op.csv_update != 0) {
				// CSVXV
				if (di_index < di->vs_index) {
					if (csv_write_header(csv_path, g_di[di_index].file_name, &g_di[di_index]) == FALSE) {
						message_get_error(GetLastError(), err_str);
						MessageBox(hDlg, err_str, APP_NAME, MB_ICONERROR);
						break;
					}
				} else {
					if (csv_write_header(csv_path, g_di[di->vs_index].file_name, &g_di[di->vs_index]) == FALSE) {
						message_get_error(GetLastError(), err_str);
						MessageBox(hDlg, err_str, APP_NAME, MB_ICONERROR);
						break;
					}
				}
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_player - vC[\
 */
BOOL show_player(const HINSTANCE hInst, const HWND hWnd, int di_index)
{
	HCURSOR old_cursor;
	TCHAR path[MAX_PATH];
	TCHAR err_str[BUF_SIZE];
	BOOL ret;

	// XRAǂݍ
	old_cursor = SetCursor(LoadCursor(NULL, IDC_WAIT));
	ZeroMemory(&csvs, sizeof(CSV_SCORE));
	csvs.csvsi_size = g_di[di_index].legs_play * 2;
	csvs.csvsi = (CSV_SCORE_INFO *)mem_calloc(sizeof(CSV_SCORE_INFO) * csvs.csvsi_size);
	*path = TEXT('\0');
	if (file_find(csv_path, g_di[di_index].file_name, path) == FALSE || csv_score_read(path, &csvs) == FALSE) {
		message_get_error(GetLastError(), err_str);
		MessageBox(hWnd, err_str, APP_NAME, MB_ICONERROR);
	}
	SetCursor(old_cursor);

	// v[[\
	ret = DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_VIEW_PLAYER), hWnd, player_proc, (LPARAM)di_index);
	csv_score_free(&csvs);
	return ret;
}
/* End of source */
