/*
 * n01_stats
 *
 * split.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>

#include "General.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern OPTION op;

/* Local Function Prototypes */
static BOOL CALLBACK split_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * split_proc - EBhEvV[W
 */
static BOOL CALLBACK split_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	RECT rect;

	switch (msg) {
	case WM_INITDIALOG:
		// Z^O
		GetWindowRect(hDlg, &rect);
		SetWindowPos(hDlg, 0,
			(GetSystemMetrics(SM_CXSCREEN) / 2) - ((rect.right - rect.left) / 2),
			(GetSystemMetrics(SM_CYSCREEN) / 2) - ((rect.bottom - rect.top) / 2),
			0, 0, SWP_NOSIZE | SWP_NOZORDER);
		// ACR\
		SendDlgItemMessage(hDlg, IDC_STATIC_ICON, STM_SETICON, (WPARAM)LoadIcon(NULL, (LPCTSTR)IDI_ASTERISK), 0);
		// ؂蕶\
		SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_SETTEXT, 0, (LPARAM)op.split_sep);
		SendDlgItemMessage(hDlg, IDC_CHECK_DELETE, BM_SETCHECK, op.split_delete, 0);
		// Beep
		MessageBeep(MB_ICONASTERISK);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			if (SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_GETTEXTLENGTH, 0, 0) <= 0) {
				break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_SEP, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)op.split_sep);
			op.split_delete = SendDlgItemMessage(hDlg, IDC_CHECK_DELETE, BM_GETCHECK, 0, 0);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_split - ؂蕶Iʕ\
 */
BOOL show_split(const HINSTANCE hInst, const HWND hWnd)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_SPLIT), hWnd, split_proc, 0);
}
/* End of source */
